<?php
/*
	Plugin Name: Cross-Promotion Content Recommendations by Engageya
	Plugin URI: http://www.Engageya.com/
	Description: Displays recommendations to your blog and other blogs, at the foot of each of your posts - for enhanced user retention as well as new engaged traffic, for free
	Version: 1.8.7
	Author:  Engageya
*/

$engageya_params = "";
$engageya_dbnurls = array();
$engageya_dbnanchors = array();
$engageya_already_shown = false;

function engageya_need_to_place_widget($content)
{
	return (is_single() || engageya_show_recommendations($content)) && (!is_feed() && !is_page());
}

function engageya_get_url_contents($url){
	$engageya_crl = curl_init();
	$engageya_timeout = 5;
	curl_setopt ($engageya_crl, CURLOPT_URL,$url);
	curl_setopt ($engageya_crl, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($engageya_crl, CURLOPT_CONNECTTIMEOUT, $engageya_timeout);
	$http_response = curl_exec($engageya_crl);
	curl_close($engageya_crl);
	return $http_response;
}

function send_log($msg)
{
	$url = urlencode(get_bloginfo('wpurl'));
	$msg = urlencode($msg);
	$ip  = urlencode($_SERVER['REMOTE_ADDR']);
	engageya_get_url_contents("http://www.engageya.com/wordpress/error/?url=" . $url . "&msg=" . $msg . "&ip=" . $ip);
}

function engageya_add_widget($content) 
{
	try
	{
		global $engageya_already_shown;
		if (engageya_need_to_place_widget($content))
		{
			global $post, $engageya_dbnurls , $engageya_dbnanchors;
			$linkToPost = get_permalink($post->ID);		
		
			if  (!$engageya_already_shown)
			{
				$engageya_already_shown = true;
				array_push($engageya_dbnurls , $linkToPost);
				array_push($engageya_dbnanchors, "spark_static_widget_" . $post->ID);
			}
			if (strpos($content, '<div id="spark_static_widget_') === false)
			{
				$content .= '<div id="spark_static_widget_'. $post->ID .'"></div>';		
			}	
		}
	}
	catch (Exception $e)
	{
		if($engageya_number_of_logs > 0)
			send_log("Exception in engageya_add_widget: " . $e->getMessage());
	}
	return $content;
}

 function engageya_add_widget_script($content)
{
	//do not write tag on homepages, or pages with no dbnanchors
	global $engageya_already_shown;
	if (!$engageya_already_shown) {
		return $content;
	}

	global $engageya_dbnurls , $engageya_dbnanchors;
	
	$grazeit_script = '<script type="text/javascript" id="wordpress_grazit_script">		
		var dbnurls = [];
		var dbnanchors = [];
';
	for($i = 0; $i < sizeof($engageya_dbnurls ); $i++)
		$grazeit_script .= "		dbnurls.push('" . $engageya_dbnurls [$i] . "');\n";
	for($i = 0; $i < sizeof($engageya_dbnanchors); $i++)
		$grazeit_script .= "		dbnanchors.push('" . $engageya_dbnanchors[$i] . "');\n";
	$grazeit_script .= '		var script = document.createElement("script");
		script.setAttribute("src", "http://widget.engageya.com/sprk.js");
		script.setAttribute("type", "text/javascript");
		script.setAttribute("id", "grazit_script");
		document.getElementById("wordpress_grazit_script").parentNode.appendChild(script);
</script>
';
	echo get_option("engageya_params_opt");
	echo $grazeit_script;
}

function engageya_initialize_widget() {

	global $engageya_params;
	if(!get_option("engageya_params_opt"))
	{
		if($engageya_params == ""){
			$engageya_params = engageya_get_url_contents("http://www.engageya.com/wordpress/register/?ver=1&url=" . urlencode (get_bloginfo('wpurl')));
		}
		update_option("engageya_params_opt", $engageya_params);
	}
}

include "templates.php";
engageya_add_all_templates();

add_filter('the_content', 'engageya_add_widget');
add_action('init', 'engageya_initialize_widget');
add_action('wp_footer', 'engageya_add_widget_script');